summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorSander Vrijders <sander.vrijders@intec.ugent.be>2016-02-12 13:27:40 +0100
committerSander Vrijders <sander.vrijders@intec.ugent.be>2016-02-12 13:27:40 +0100
commita59d0c7b448597865c679c9d19ee13de742cea02 (patch)
treeef683a73a509eed0aaf2dac9ce197cb2082ea29f
parent4944a01444f146fdfb1a45ed346b5bc4744c0a45 (diff)
downloadouroboros-a59d0c7b448597865c679c9d19ee13de742cea02.tar.gz
ouroboros-a59d0c7b448597865c679c9d19ee13de742cea02.zip
include: Add logging infrastructure
Adds the logging infrastructure to the prototype. 2 helper scripts are also provided to compile the prototype in either release or debug mode. In debug mode debugging logs are printed.
-rw-r--r--CMakeLists.txt7
-rwxr-xr-xcompile_debug.sh35
-rwxr-xr-xcompile_release.sh35
-rw-r--r--include/ouroboros/logs.h45
-rw-r--r--src/da/main.c6
-rw-r--r--src/ipcp/main.c6
-rw-r--r--src/irm/main.c6
7 files changed, 134 insertions, 6 deletions
diff --git a/CMakeLists.txt b/CMakeLists.txt
index 1c96ce66..6685dc2f 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -46,6 +46,13 @@ add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tests)
+include(MacroAddCompileFlags)
+if (CMAKE_BUILD_TYPE MATCHES Debug)
+ MACRO_ADD_COMPILE_FLAGS(ipcp -DCONFIG_OUROBOROS_DEBUG)
+ MACRO_ADD_COMPILE_FLAGS(irm -DCONFIG_OUROBOROS_DEBUG)
+ MACRO_ADD_COMPILE_FLAGS(da -DCONFIG_OUROBOROS_DEBUG)
+endif (CMAKE_BUILD_TYPE MATCHES Debug)
+
include(FeatureSummary)
print_enabled_features()
diff --git a/compile_debug.sh b/compile_debug.sh
new file mode 100755
index 00000000..0b21b336
--- /dev/null
+++ b/compile_debug.sh
@@ -0,0 +1,35 @@
+#!/bin/bash
+
+ME=compile_debug
+
+if (($# == 1 ))
+then
+ PREFIX=`echo "$1"|sed -e "s,\/$,,"`
+else
+ PREFIX="/usr/local/ouroboros"
+fi
+
+BUILDDIR=build
+DEBUGDIR=debug
+
+echo "$ME: Prefix is $PREFIX"
+
+echo "$ME: Build directory will be '$BUILDDIR'"
+if test -n "$BUILDDIR" ; then
+ mkdir -p $BUILDDIR || {
+ echo "$ME: Cannot create directory '$BUILDDIR'"
+ }
+fi
+cd $BUILDDIR
+
+echo "$ME: Debug directory will be '$DEBUGDIR'"
+if test -n "$DEBUGDIR" ; then
+ mkdir -p $DEBUGDIR || {
+ echo "$ME: Cannot create directory '$DEBUGDIR'"
+ }
+fi
+cd $DEBUGDIR
+
+cmake -DCMAKE_INSTALL_PREFIX=$PREFIX -DCMAKE_BUILD_TYPE=Debug ../..
+
+make
diff --git a/compile_release.sh b/compile_release.sh
new file mode 100755
index 00000000..0dad6c91
--- /dev/null
+++ b/compile_release.sh
@@ -0,0 +1,35 @@
+#!/bin/bash
+
+ME=compile_release
+
+if (($# == 1 ))
+then
+ PREFIX=`echo "$1"|sed -e "s,\/$,,"`
+else
+ PREFIX="/usr/local/ouroboros"
+fi
+
+BUILDDIR=build
+RELEASEDIR=release
+
+echo "$ME: Prefix is $PREFIX"
+
+echo "$ME: Build directory will be '$BUILDDIR'"
+if test -n "$BUILDDIR" ; then
+ mkdir -p $BUILDDIR || {
+ echo "$ME: Cannot create directory '$BUILDDIR'"
+ }
+fi
+cd $BUILDDIR
+
+echo "$ME: Release directory will be '$RELEASEDIR'"
+if test -n "$RELEASEDIR" ; then
+ mkdir -p $RELEASEDIR || {
+ echo "$ME: Cannot create directory '$RELEASEDIR'"
+ }
+fi
+cd $RELEASEDIR
+
+cmake -DCMAKE_INSTALL_PREFIX=$PREFIX -DCMAKE_BUILD_TYPE=Release ../..
+
+make
diff --git a/include/ouroboros/logs.h b/include/ouroboros/logs.h
new file mode 100644
index 00000000..5366e266
--- /dev/null
+++ b/include/ouroboros/logs.h
@@ -0,0 +1,45 @@
+/*
+ * Logging facilities
+ *
+ * Sander Vrijders <sander.vrijders@intec.ugent.be>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#ifndef OUROBOROS_LOGS_H
+#define OUROBOROS_LOGS_H
+
+#include <stdio.h>
+
+#ifndef OUROBOROS_PREFIX
+#error You must define OUROBOROS_PREFIX before including this file
+#endif
+
+#define __LOG(PFX, LVL, FMT, ARGS...) \
+ do { printf(PFX "(" LVL "): " FMT "\n", ##ARGS); } while (0)
+
+#define LOG_ERR(FMT, ARGS...) __LOG(OUROBOROS_PREFIX, "ERR", FMT, ##ARGS)
+#define LOG_WARN(FMT, ARGS...) __LOG(OUROBOROS_PREFIX, "WARN", FMT, ##ARGS)
+#define LOG_INFO(FMT, ARGS...) __LOG(OUROBOROS_PREFIX, "INFO", FMT, ##ARGS)
+
+#ifdef CONFIG_OUROBOROS_DEBUG
+#define LOG_DBG(FMT, ARGS...) __LOG(OUROBOROS_PREFIX, "DBG", FMT, ##ARGS)
+#else
+#define LOG_DBG(FMT, ARGS...) do { } while (0)
+#endif
+
+#define LOG_MISSING LOG_ERR("Missing code in %s:%d",__FILE__, __LINE__)
+
+#endif
diff --git a/src/da/main.c b/src/da/main.c
index 2eeb7b36..e2971dca 100644
--- a/src/da/main.c
+++ b/src/da/main.c
@@ -1,8 +1,10 @@
-#include <stdio.h>
+#define OUROBOROS_PREFIX "da"
+
+#include <ouroboros/logs.h>
int main()
{
- printf("Test of the DA\n");
+ LOG_DBG("Test of the DA");
return 0;
}
diff --git a/src/ipcp/main.c b/src/ipcp/main.c
index 19397260..b67b0af9 100644
--- a/src/ipcp/main.c
+++ b/src/ipcp/main.c
@@ -1,8 +1,10 @@
-#include <stdio.h>
+#define OUROBOROS_PREFIX "ipcp"
+
+#include <ouroboros/logs.h>
int main()
{
- printf("Test of the IPCP\n");
+ LOG_DBG("Test of the IPCP");
return 0;
}
diff --git a/src/irm/main.c b/src/irm/main.c
index 6388427f..8ab071e0 100644
--- a/src/irm/main.c
+++ b/src/irm/main.c
@@ -1,8 +1,10 @@
-#include <stdio.h>
+#define OUROBOROS_PREFIX "irm"
+
+#include <ouroboros/logs.h>
int main()
{
- printf("Test of the IRM\n");
+ LOG_DBG("Test of the IRM");
return 0;
}